Subject: Re: IPv6 Destination Options question

From: Christoph Grenz <[email-masked]>
Date: Sat, 14 Dec 2019 22:11:01 +0100

Hi Tom,

my receive code boils down to this Python script:

--------------------------------------------------------------------
#!/usr/bin/env python3

from socket import socket, AF_INET6, IPPROTO_IPV6, IPV6_RECVDSTOPTS, SOCK_RAW

IPPROTO_MH = 135 # IPv6 Mobility Header

sock = socket(AF_INET6, SOCK_RAW, IPPROTO_MH)
sock.setsockopt(IPPROTO_IPV6, IPV6_RECVDSTOPTS, True)

sock.bind(('::',  0))

while True:
	packet, ancdata, msg_flags, address = sock.recvmsg(1800, 512)
	print(address[0], packet.hex(), ancdata)

--------------------------------------------------------------------

Best regards,
Christoph

Am Samstag, 14. Dezember 2019, 12:40:16 CET schrieb Tom Herbert:
> On Sat, Dec 14, 2019 at 8:19 AM Christoph Grenz
> 
> <[email-masked]> wrote:
> > Hello,
> > 
> > I'm playing around with Mobile IPv6 and noticed a strange behaviour in the
> > Linux network system when using IPv6 destination options:
> > 
> > I'm able to send destination options on SOCK_DGRAM and SOCK_RAW sockets
> > with sendmsg() and IPV6_DSTOPTS ancillary data. The sent packets also
> > look correct in Wireshark.
> > 
> > But I'm not able to receive packets with destination options on a socket
> > with the IPV6_RECVDSTOPTS socket option enabled. Both a packet with a
> > Home Address Option and a packet with an empty destination options header
> > (only containing padding) won't be received on a socket for the payload
> > protocol.
> 
> Christoph, Can you post your receive code?
> 
> Thanks
> 
> > Only a SOCK_RAW socket for IPPROTO_DSTOPTS receives the packet.
> > 
> > I tested this on a vanilla 5.4.0 kernel and got the same behaviour.
> > Activating dyndbg for everything in net/ipv6 didn't produce any relevant
> > output in dmesg.
> > 
> > Is this expected behaviour or a bug? Or do I maybe need some other socket
> > option or a xfrm policy to receive packets with destination options?
> > 
> > Best regards
> > Christoph